from edge.admin.ui_types import BaseCreator

from edge.path_helpers import *


# noinspection PyUnusedLocal
def lens_try_get_creator_ctor(ui_entry_point, used_ui_modules, used_edge_modules, avaliable_ui_modules):
    """
    :type ui_entry_point: UiIdentity
    :type used_ui_modules: set of UiIdentity
    :type used_edge_modules: set of EdgeIdentity
    :type avaliable_ui_modules: set of UiIdentity
    :rtype: None | (str, UiIdentity, dict of UiIdentity: dict) -> BaseCreator
    """
    creator_ctor = None
    if ui_entry_point in [Pipeline.Speed.Ui.LENS_0]:
        used_ui_modules.add(Pipeline.Speed.Ui.LENS_0)
        creator_ctor = LensCreator.create

    elif ui_entry_point in [Pipeline.Mv.Ui.LENS_0]:
        used_ui_modules.add(Pipeline.Mv.Ui.LENS_0)
        creator_ctor = LensCreator.create

    return creator_ctor


class LensCreator(BaseCreator):
    def __init__(self):
        BaseCreator.__init__(self)

    # noinspection PyUnusedLocal
    @staticmethod
    def create(ui_pid, ui_entry_point, ui_identity_to_jnode_map):
        """
        :type ui_pid: str
        :type ui_entry_point: UiIdentity
        :type ui_identity_to_jnode_map: dict of UiIdentity: dict
        :rtype: LensCreator
        """
        return LensCreator()

    def serialize(self):
        pass
